%{!?buildid: %{expand: %%define buildid 1}}

%global selinuxtype     targeted
%global selinux_policyver 3.12.1-153.el7_0.10
%global modulenames	xenstored_policy xenconsoled_policy
# Usage: _format var format
#   Expand 'modulenames' into various formats as needed
#   Format must contain '$x' somewhere to do anything useful
%global _format() export %1=""; for x in %{modulenames}; do %1+=%2; %1+=" "; done;

Name: xen
Version: 4.7.0
Release:    4.el6
Summary: Xen hypervisor
Group: Development/Libraries
License: GPLv2+ and LGPLv2+ and BSD
URL: http://www.xenproject.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
Source0: xen-4.7.tar.gz
BuildRequires: transfig
BuildRequires: libidn-devel
BuildRequires: curl-devel
BuildRequires: python-devel
BuildRequires: gettext
BuildRequires: ncurses-devel
BuildRequires: libaio-devel
BuildRequires: libxml2-devel
BuildRequires: flex
BuildRequires: bison
BuildRequires: pciutils-devel
BuildRequires: SDL-devel
BuildRequires: openssl-devel
BuildRequires: yajl-devel
BuildRequires: libuuid-devel
BuildRequires: e2fsprogs-devel
BuildRequires: ocaml
BuildRequires: ocaml-findlib
BuildRequires: glib2-devel
BuildRequires: wget
BuildRequires: pkgconfig
BuildRequires: pixman-devel
BuildRequires: checkpolicy
BuildRequires: zlib-devel
BuildRequires: bzip2-devel
BuildRequires: perl
BuildRequires: module-init-tools >= 3.3-0.pre3.1.16
BuildRequires: dev86
BuildRequires: iasl
BuildRequires: libibverbs-devel
BuildRequires: librdmacm-devel
BuildRequires: nasm
BuildRequires: pixman
BuildRequires: nss-devel
BuildRequires: gnutls-devel
BuildRequires: gtk2-devel
BuildRequires: m4
BuildRequires: gcc
BuildRequires: libtool

%if 0%{?el6}
BuildRequires: iasl
%else
BuildRequires: acpica-tools
BuildRequires: systemd-devel
%endif

%description
Xen hypervisor

%package tools
Summary: Xen tools
Group: Development/Libraries
Requires: libxenstore = %{version}-%{release}
Requires: libibverbs
Requires: librdmacm
Requires: bridge-utils
Requires: util-linux >= 2.13-0.45
Requires: kpartx
Requires: pixman

%description tools
Xen tools

%if 0%{?el7}
%package tools-selinux
Summary: Xen SELinux policies
BuildArch: noarch
Group: System Environment/Base
Requires: policycoreutils, libselinux-utils
Requires(post): selinux-policy-base >= %{selinux_policyver}, selinux-policy-targeted >= %{selinux_policyver}, policycoreutils, policycoreutils-python
Requires(postun): policycoreutils
BuildRequires: selinux-policy selinux-policy-devel

%description tools-selinux
SELinux additional modules for use with Xen
%endif

%package devel
Summary: Xen development libraries
Group: Development/Libraries
Requires: libxenstore = %{version}-%{release}
Requires: xen-tools = %{version}-%{release}

%description devel
Xen development libraries

%package -n libxenstore
Summary: Xenstore libraries
Group: Development/Libraries

%description -n libxenstore
Xenstore libraries

%package -n libxenstore-devel
Summary: Xenstore development libraries
Group: Development/Libraries

%description -n libxenstore-devel
Xenstore development libraries

%prep
%setup -q -n xen-4.7

%build
./configure --prefix=/usr --libdir=/usr/lib64 --libexecdir=/usr/libexec --enable-ovmf
cat << EOF > xen/.config
CONFIG_NR_CPUS=512
CONFIG_LIVEPATCH=y
CONFIG_FAST_SYMBOL_LOOKUP=y
CONFIG_BIGMEM=y
EOF

yes "" | make -C xen oldconfig

unset CFLAGS
make %{?_smp_mflags} dist-xen

export CFLAGS_EXTRA="$RPM_OPT_FLAGS"
make %{?_smp_mflags} dist-tools dist-docs

%if 0%{?el7}
make -f /usr/share/selinux/devel/Makefile xenstored_policy.pp
make -f /usr/share/selinux/devel/Makefile xenconsoled_policy.pp
make -f /usr/share/selinux/devel/Makefile xen.fc
%endif

%install
unset CFLAGS
make %{?_smp_mflags} DESTDIR=$RPM_BUILD_ROOT install-xen

export CFLAGS_EXTRA="$RPM_OPT_FLAGS"
make %{?_smp_mflags} DESTDIR=$RPM_BUILD_ROOT install-tools install-docs

make %{?_smp_mflags} clean-xen
# Which sadly erases .config.
# We regenerate it here as in the future Xen with have an CONFIG_DEBUG
cat << EOF > xen/.config
CONFIG_NR_CPUS=512
CONFIG_LIVEPATCH=y
CONFIG_FAST_SYMBOL_LOOKUP=y
CONFIG_BIGMEM=y
EOF

yes "" | make -C xen oldconfig

unset CFLAGS
make %{?_smp_mflags} debug=y dist-xen

install -m0644 -p xen/xen.gz $RPM_BUILD_ROOT/boot/%{name}-%{version}-debug.gz
install -m0644 -p xen/xen-syms $RPM_BUILD_ROOT/usr/lib/debug/%{name}-syms-%{version}-debug

%if !0%{?el6}
# Use systemd and remove these SysV init scripts.
rm -fr $RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/
%endif

%if 0%{?el7}
%_format MODULES $x.pp
install -d $RPM_BUILD_ROOT%{_datadir}/selinux/packages
install -m0644 $MODULES $RPM_BUILD_ROOT%{_datadir}/selinux/packages
install -m0644 xen.fc $RPM_BUILD_ROOT%{_datadir}/selinux/packages
%endif

install -m0644 README $RPM_BUILD_ROOT%{_datadir}/doc/xen/README
install -m0644 COPYING $RPM_BUILD_ROOT%{_datadir}/doc/xen/COPYING

%if 0%{?el6}
%post tools
/sbin/ldconfig
/sbin/chkconfig --add xencommons
/sbin/chkconfig --add xendomains

%preun tools
if [ $1 = 0 ]; then
  /sbin/chkconfig --del xencommons
  /sbin/chkconfig --del xendomains
fi

%postun tools
/sbin/ldconfig
%else
%post
if [ $1 == 1 -a -f /sbin/grub2-mkconfig -a -f /boot/grub2/grub.cfg ]; then
    /sbin/grub2-mkconfig -o /boot/grub2/grub.cfg
fi

%postun
if [ -f /sbin/grub2-mkconfig -a -f /boot/grub2/grub.cfg ]; then
    /sbin/grub2-mkconfig -o /boot/grub2/grub.cfg
fi

%post tools
%systemd_post xen-init-dom0.service xen-qemu-dom0-disk-backend.service xendomains.service xenstored.service xenconsoled.service
/sbin/ldconfig

%if 0%{?el7}
%post tools-selinux
%_format MODULES %{_datadir}/selinux/packages/$x.pp
%{_sbindir}/semodule -s %{selinuxtype} -i $MODULES
%{_sbindir}/semanage fcontext -a -t xen_device_t /dev/xen/privcmd
if %{_sbindir}/selinuxenabled ; then
        %{_sbindir}/load_policy
	%{_sbindir}/restorecon -Rv /dev/xen/privcmd
fi
%endif

%preun tools
%systemd_preun xen-init-dom0.service xen-qemu-dom0-disk-backend.service xendomains.service xenstored.service xenconsoled.service

%postun tools
%systemd_postun
/sbin/ldconfig
%endif

%post -n libxenstore
/sbin/ldconfig

%postun -n libxenstore
/sbin/ldconfig

%if 0%{?el7}
%postun tools-selinux
if [ $1 -eq 0 ]; then
        %{_sbindir}/semodule -n -r $MODULES &> /dev/null || :
        if %{_sbindir}/selinuxenabled ; then
                %{_sbindir}/load_policy
		%{_sbindir}/restorecon -Rv /dev/xen/privcmd
        fi
fi
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/boot/*

%files tools
%config(noreplace) %{_sysconfdir}/sysconfig/*
%{_sysconfdir}/bash_completion.d/xl.sh
%{_sysconfdir}/xen
%{_sbindir}/*
%{_bindir}/pygrub
%{_bindir}/qemu-img-xen
%{_bindir}/qemu-nbd-xen
%{_bindir}/xen-cpuid
%{_bindir}/xen-detect
%{_bindir}/xenalyze
%{_bindir}/xencons
%{_bindir}/xencov_split
%{_bindir}/xentrace_format

%{_libdir}/fs/
%{_libdir}/libblktapctl.so*
%{_libdir}/libfsimage.so*
%{_libdir}/libvhd.so*
%{_libdir}/libxencall.so*
%{_libdir}/libxenctrl.so*
%{_libdir}/libxenevtchn.so*
%{_libdir}/libxenforeignmemory.so*
%{_libdir}/libxengnttab.so*
%{_libdir}/libxenguest.so*
%{_libdir}/libxenlight.so*
%{_libdir}/libxenstat.so*
%{_libdir}/libxentoollog.so*
%{_libdir}/libxenvchan.so*
%{_libdir}/libxlutil.so*
%{_libdir}/ocaml/

%{python_sitearch}/
/usr/libexec/xen/boot/hvmloader
/usr/libexec/xen/bin/

%{_datadir}/xen/qemu
%{_datadir}/qemu-xen
/usr/libexec/xen/libexec/qemu-bridge-helper

/usr/libexec/xen/lib/*.so*
/usr/libexec/xen/share/locale

%dir %{_localstatedir}/lib/xen/dump
%dir %{_localstatedir}/lib/xen/xenpaging
%dir %attr(0700,root,root) %{_localstatedir}/log/xen

%{_datadir}/doc/xen/README
%{_datadir}/doc/xen/html/
%{_mandir}/man1/xentop.1.gz
%{_mandir}/man1/xentrace_format.1.gz
%{_mandir}/man1/xl.1.gz
%{_mandir}/man5/xl.cfg.5.gz
%{_mandir}/man5/xl.conf.5.gz
%{_mandir}/man5/xlcpupool.cfg.5.gz
%{_mandir}/man8/xentrace.8.gz

%if 0%{?el6}
%{_sysconfdir}/rc.d/init.d/*
%{_libdir}/efi/
%else
%{_unitdir}/proc-xen.mount
%{_unitdir}/var-lib-xenstored.mount
%{_unitdir}/xen-init-dom0.service
%{_unitdir}/xen-qemu-dom0-disk-backend.service
%{_unitdir}/xen-watchdog.service
%{_unitdir}/xenconsoled.service
%{_unitdir}/xendomains.service
%{_unitdir}/xenstored.service
%{_unitdir}/xenstored.socket
%{_unitdir}/xenstored_ro.socket
/usr/lib/modules-load.d/xen.conf
%endif

%files devel
%defattr(-,root,root)
%{_includedir}/_libxl_list.h
%{_includedir}/_libxl_types.h
%{_includedir}/_libxl_types_json.h
%{_includedir}/fsimage.h
%{_includedir}/fsimage_grub.h
%{_includedir}/fsimage_plugin.h
%{_includedir}/libxenvchan.h
%{_includedir}/libxl.h
%{_includedir}/libxl_event.h
%{_includedir}/libxl_json.h
%{_includedir}/libxl_utils.h
%{_includedir}/libxl_uuid.h
%{_includedir}/libxlutil.h
%{_includedir}/xen/COPYING
%{_includedir}/xen/*.h
%{_includedir}/xen/arch-arm/
%{_includedir}/xen/arch-x86/
%{_includedir}/xen/foreign/
%{_includedir}/xen/hvm/
%{_includedir}/xen/io/console.h
%{_includedir}/xen/io/blkif.h
%{_includedir}/xen/io/xenbus.h
%{_includedir}/xen/io/kbdif.h
%{_includedir}/xen/io/libxenvchan.h
%{_includedir}/xen/io/fbif.h
%{_includedir}/xen/io/vscsiif.h
%{_includedir}/xen/io/usbif.h
%{_includedir}/xen/io/fsif.h
%{_includedir}/xen/io/tpmif.h
%{_includedir}/xen/io/protocols.h
%{_includedir}/xen/io/ring.h
%{_includedir}/xen/io/pciif.h
%{_includedir}/xen/io/netif.h
%{_includedir}/xen/sys/
%{_includedir}/xen/xsm/
%{_includedir}/xencall.h
%{_includedir}/xenctrl.h
%{_includedir}/xenctrl_compat.h
%{_includedir}/xenevtchn.h
%{_includedir}/xenforeignmemory.h
%{_includedir}/xengnttab.h
%{_includedir}/xenguest.h
%{_includedir}/xenstat.h
%{_includedir}/xentoollog.h
%{_libdir}/libblktapctl.a
%{_libdir}/libvhd.a
%{_libdir}/libxencall.a
%{_libdir}/libxenctrl.a
%{_libdir}/libxenevtchn.a
%{_libdir}/libxenforeignmemory.a
%{_libdir}/libxengnttab.a
%{_libdir}/libxenguest.a
%{_libdir}/libxenlight.a
%{_libdir}/libxenstat.a
%{_libdir}/libxentoollog.a
%{_libdir}/libxenvchan.a
%{_libdir}/libxlutil.a
%{_datadir}/pkgconfig/*.pc
/usr/libexec/xen/include/*
/usr/libexec/xen/lib/*.a
/usr/libexec/xen/lib/*.la
/usr/libexec/xen/lib/pkgconfig/*.pc

%files -n libxenstore
%defattr(-,root,root)
%{_datadir}/doc/xen/COPYING
%{_bindir}/xenstore*
%{_libdir}/libxenstore.so*
%{_mandir}/man1/xenstore-chmod.1.gz
%{_mandir}/man1/xenstore-ls.1.gz
%{_mandir}/man1/xenstore.1.gz

%files -n libxenstore-devel
%defattr(-,root,root)
%{_includedir}/xen/io/xs_wire.h
%{_includedir}/xenstore-compat/
%{_includedir}/xenstore.h
%{_includedir}/xenstore_lib.h
%{_includedir}/xs.h
%{_includedir}/xs_lib.h
%{_libdir}/libxenstore.a

%if 0%{?el7}
%files tools-selinux
%attr(0644,root,root) %{_datadir}/selinux/packages/*.pp
%attr(0644,root,root) %{_datadir}/selinux/packages/*.fc
%endif
%changelog
* Thu Jun 23 2016 Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> - 4.7.0-4.el6
- BUILDINFO: commit=fb87cd9fa980c4daebc490c2280342ebf80e21c4
- xen.spec: s/CONFIG_XSPLICE/CONFIG_LIVEPATCH/ (Konrad Rzeszutek Wilk)  
- livepatch: Add support for shadow variables. (Ross Lagerwall)  
- livepach: Add .livepatch.hooks functions and test-case (Ross Lagerwall)  
- Revert "xsplice: Add .xsplice.hooks functions and test-case" (Konrad Rzeszutek Wilk)  
- Revert "xsplice: Add support for shadow variables." (Konrad Rzeszutek Wilk)  

* Mon Jun 20 2016 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.7.0-3.el6
- BUILDINFO: commit=8d86f5510b6c05f6ac985e1ad44ad74a421dc5ee
- RPM build: fix OL7 RPM build error for "tools/libs/toollog/xtl_core.c" (Zhigang Wang)  
- xen.spec: move COPYING to libxenstore RPM (Zhigang Wang)  
- xen.spec: cleanup: make commands and variables usage consistent (Zhigang Wang)

* Mon May 30 2016 Tianyue Lan <tianyue.lan@oracle.com> - 4.7.0-2.el6
- Rebuilt

